## net.sf.saxon.expr
Class SlashExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.SlashExpression

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, ContextMappingFunction, EvaluableItem, SequenceIterable, InstructionInfo, org.xml.sax.Locator

Direct Known Subclasses:
  AtomicMappingExpression, PathExpression

    public class SlashExpression

extends Expression
implements ContextMappingFunction

A slash expression is any expression using the binary slash operator "/". The parser initially generates a slash expression for all occurrences of the binary "/" operator. Subsequently, as a result of type inferencing, the majority of slash expressions will be rewritten as instances of PathExpression (returning nodes) or AtomicMappingExpressions (returning atomic values). However, in the rare case where it is not possible to determine statically whether the rh operand returns nodes or atomic values, instances of this class may need to be interpreted directly at run time.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`SlashExpression(Expression start, Expression step)` Constructor

Method Summary
`int` `computeCardinality()` Determine the static cardinality of the expression
`int` `computeDependencies()` Determine which aspects of the context the expression depends on.
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` `copy()` Copy an expression.
`boolean` `equals(java.lang.Object other)` Is this expression the same as another expression?
`void` `explain(ExpressionPresenter destination)` Diagnostic print of expression structure.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this exprssion
`Expression` `getStartExpression()` Get the start expression (the left-hand operand)
`Expression` `getStepExpression()` Get the step expression (the right-hand operand)
`int` `hashCode()` get HashCode for comparing two expressions
`boolean` `hasLoopingSubexpression(Expression child)` Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly
`boolean` `isHybrid()` Determine whether this expression is capable (as far as static analysis is concerned) of returning a mixture of nodes and atomic values.
`SequenceIterator` `iterate(XPathContext context)` Iterate the path-expression in a given context
`java.util.Iterator` `iterateSubExpressions()` Get the immediate subexpressions of this expression
`static SlashExpression` `makeSlashExpression(Expression start, Expression step, TypeHierarchy th)` Static factory method, allowing early instantiation of a subclass if the type of the step expression is already known
`SequenceIterator` `map(XPathContext context)` Mapping function, from a node returned by the start iteration, to a sequence returned by the child.
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` `promote(PromotionOffer offer)` Promote this expression if possible
`protected Expression` `promoteFocusIndependentSubexpressions(ExpressionVisitor visitor, ItemType contextItemType)` If any subexpressions within the step are not dependent on the focus, and if they are not "creative" expressions (expressions that can create new nodes), then promote them: this causes them to be evaluated once, outside the path expression
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`protected void` `setStartExpression(Expression start2)`
`protected void` `setStepExpression(Expression step2)`
`Expression` `simplify(ExpressionVisitor visitor)` Simplify an expression
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toString, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SlashExpression

    public SlashExpression(Expression start,
                           Expression step)

  Constructor

  Parameters:
    `start` - The left hand operand (which must always select a sequence of nodes).
    `step` - The step to be followed from each node in the start expression to yield a new sequence; this may return either nodes or atomic values (but not a mixture of the two)

Method Detail

### setStartExpression

    protected void setStartExpression(Expression start2)

### setStepExpression

    protected void setStepExpression(Expression step2)

### makeSlashExpression

    public static SlashExpression makeSlashExpression(Expression start,
                                                      Expression step,
                                                      TypeHierarchy th)

  Static factory method, allowing early instantiation of a subclass if the type of the step expression is already known

### getStartExpression

    public Expression getStartExpression()

  Get the start expression (the left-hand operand)

  Returns:
    the first operand

### getStepExpression

    public Expression getStepExpression()

  Get the step expression (the right-hand operand)

  Returns:
    the second operand

### isHybrid

    public boolean isHybrid()

  Determine whether this expression is capable (as far as static analysis is concerned) of returning a mixture of nodes and atomic values. If so, this needs to be prevented at run time

  Returns:
    true if the static type allows both nodes and atomic values

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Parameters:
    `visitor` - the expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this exprssion

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the type of the step

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### promoteFocusIndependentSubexpressions

    protected Expression promoteFocusIndependentSubexpressions(ExpressionVisitor visitor,
                                                               ItemType contextItemType)
                                                        throws XPathException

  If any subexpressions within the step are not dependent on the focus, and if they are not "creative" expressions (expressions that can create new nodes), then promote them: this causes them to be evaluated once, outside the path expression

  Parameters:
    `visitor` - the expression visitor
    `contextItemType` - the type of the context item for evaluating the start expression
  Returns:
    the rewritten expression, or the original expression if no rewrite was possible
  Throws:
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### hasLoopingSubexpression

    public boolean hasLoopingSubexpression(Expression child)

  Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly

  Overrides:
    `hasLoopingSubexpression` in class `Expression`
  Parameters:
    `child` - the immediate subexpression
  Returns:
    true if the child expression is evaluated repeatedly

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### computeDependencies

    public int computeDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    the depencies, as a bit-mask

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    the special properties, as a bit-significant integer

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `java.lang.Object`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate the path-expression in a given context

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### map

    public final SequenceIterator map(XPathContext context)
                               throws XPathException

  Mapping function, from a node returned by the start iteration, to a sequence returned by the child.

  Specified by:
    `map` in interface `ContextMappingFunction`
  Parameters:
    `context` - The processing context. The item to be mapped is the context item identified from this context: the values of position() and last() also relate to the set of items being mapped
  Returns:
    a SequenceIterator over the sequence of items that the supplied input item maps to
  Throws:
    `XPathException`

### explain

    public void explain(ExpressionPresenter destination)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `destination` - the expression presenter used to display the structure

Copyright (c) Saxonica Limited. All rights reserved.